---
title: AudioNode.disconnect()
slug: Web/API/AudioNode/disconnect
tags:
  - API
  - Audio
  - AudioNode
  - Disconnect
  - Method
  - Reference
  - Web Audio API
---
<p>{{ APIRef("Web Audio API") }}</p>

<div>
<p>The <strong><code>disconnect()</code></strong> method of the {{ domxref("AudioNode") }} interface lets you disconnect one or more nodes from the node on which the method is called.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js"><em>AudioNode</em>.disconnect();

<em>AudioNode</em>.disconnect(<em>output</em>);

<em>AudioNode</em>.disconnect(<em>destination</em>);

<em>AudioNode</em>.disconnect(<em>destination</em>, <em>output</em>);

<em>AudioNode</em>.disconnect(<em>destination</em>, <em>output</em>, <em>input</em>);
</pre>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}</p>

<h3 id="Parameters">Parameters</h3>

<p>There are several versions of the <code>disconnect()</code> method, which accept different combinations of parameters to control which nodes to disconnect from. If no parameters are provided, all outgoing connections are disconnected.</p>

<dl>
 <dt><code>destination</code> {{optional_inline}}</dt>
 <dd>An {{domxref("AudioNode")}} or {{domxref("AudioParam")}} specifying the node or nodes to disconnect from. If this value is an <code>AudioNode</code>, a single node is disconnected from, with any other, optional, parameters (<code>output</code> and/or <code>input</code>) further limiting which inputs and/or outputs should be disconnected. If this value is an <code>AudioParam</code>, then the connection to that <code>AudioParam</code> is terminated, and the node's contributions to that computed parameter become 0 going forward once the change takes effect. If no matching connection is found, an <code>InvalidAccessError</code> exception is thrown.</dd>
 <dt><code>output</code> {{optional_inline}}</dt>
 <dd>An index describing which output from the current <code>AudioNode</code> is to be disconnected. The index numbers are defined according to the number of output channels (see <a href="/en-US/docs/Web/API/Web_Audio_API/Basic_concepts_behind_Web_Audio_API#Audio_channels">Audio channels</a>). If this parameter is out-of-bound, an <code>IndexSizeError</code> exception is thrown.</dd>
 <dt><code>input</code> {{optional_inline}}</dt>
 <dd>An index describing which input into the specified destination <code>AudioNode</code> is to be disconnected. The index numbers are defined according to the number of input channels (see <a href="/en-US/docs/Web/API/Web_Audio_API/Basic_concepts_behind_Web_Audio_API#Audio_channels">Audio channels</a>).  If this parameter is out-of-bound, an <code>IndexSizeError</code> exception is thrown.</dd>
</dl>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>IndexSizeError</code></dt>
 <dd>A value specified for <code>input</code> or <code>output</code> is invalid, referring to a node which doesn't exist or outside the permitted range.</dd>
 <dt><code>InvalidAccessError</code></dt>
 <dd>The node on which <code>disconnect()</code> was called isn't connected to the specified <code>destination</code> node.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">var AudioContext = window.AudioContext || window.webkitAudioContext;

var audioCtx = new AudioContext();

var oscillator = audioCtx.createOscillator();
var gainNode = audioCtx.createGain();

oscillator.connect(gainNode);
gainNode.connect(audioCtx.destination);

gainNode.disconnect();
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audionode-disconnect', 'disconnect')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioNode.disconnect")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
